<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8"/>
    <title>type_check.ml &mdash; Coverage report</title>
    <meta name="description" content="74.47% coverage in lib/type_check.ml">
    <link rel="stylesheet" href="../coverage.css"/>
    <script src="../highlight.pack.js"></script>
    <script>hljs.initHighlightingOnLoad();</script>
  </head>
  <body>
    <div id="header">
      <h1>
        <a href="../index.html">
          <span class="dirname">lib/</span>type_check.ml
        </a>
      </h1>
      <h2>74.47%</h2>
    </div>
    <div id="navbar">
      <span class="unvisited" style="top:4.10%"></span>
      <span class="unvisited" style="top:20.49%"></span>
      <span class="unvisited" style="top:27.87%"></span>
      <span class="unvisited" style="top:29.51%"></span>
      <span class="unvisited" style="top:40.98%"></span>
      <span class="unvisited" style="top:42.62%"></span>
      <span class="unvisited" style="top:50.00%"></span>
      <span class="unvisited" style="bottom:47.54%"></span>
      <span class="unvisited" style="bottom:46.72%"></span>
      <span class="unvisited" style="bottom:39.34%"></span>
      <span class="unvisited" style="bottom:36.89%"></span>
      <span class="unvisited" style="bottom:36.07%"></span>
      <span class="unvisited" style="bottom:26.23%"></span>
      <span class="unvisited" style="bottom:22.13%"></span>
      <span class="unvisited" style="bottom:7.38%"></span>
      <span class="unvisited" style="bottom:5.74%"></span>
      <span class="unvisited" style="bottom:4.92%"></span>
      <span class="unvisited" style="bottom:2.46%"></span>
    </div>
    <div id="report">
      <div id="lines-layer">
        <pre>
<a id="L1"></a><span > </span>
<a id="L2"></a><span > </span>
<a id="L3"></a><span > </span>
<a id="L4"></a><span > </span>
<a id="L5"></a><span class="unvisited"> </span>
<a id="L6"></a><span > </span>
<a id="L7"></a><span > </span>
<a id="L8"></a><span class="visited"> </span>
<a id="L9"></a><span class="visited"> </span>
<a id="L10"></a><span > </span>
<a id="L11"></a><span > </span>
<a id="L12"></a><span > </span>
<a id="L13"></a><span class="visited"> </span>
<a id="L14"></a><span > </span>
<a id="L15"></a><span > </span>
<a id="L16"></a><span class="visited"> </span>
<a id="L17"></a><span > </span>
<a id="L18"></a><span > </span>
<a id="L19"></a><span > </span>
<a id="L20"></a><span class="visited"> </span>
<a id="L21"></a><span > </span>
<a id="L22"></a><span class="visited"> </span>
<a id="L23"></a><span > </span>
<a id="L24"></a><span class="visited"> </span>
<a id="L25"></a><span class="unvisited"> </span>
<a id="L26"></a><span > </span>
<a id="L27"></a><span > </span>
<a id="L28"></a><span class="visited"> </span>
<a id="L29"></a><span class="visited"> </span>
<a id="L30"></a><span class="visited"> </span>
<a id="L31"></a><span class="visited"> </span>
<a id="L32"></a><span > </span>
<a id="L33"></a><span class="visited"> </span>
<a id="L34"></a><span class="unvisited"> </span>
<a id="L35"></a><span class="visited"> </span>
<a id="L36"></a><span class="unvisited"> </span>
<a id="L37"></a><span class="visited"> </span>
<a id="L38"></a><span > </span>
<a id="L39"></a><span class="visited"> </span>
<a id="L40"></a><span class="visited"> </span>
<a id="L41"></a><span > </span>
<a id="L42"></a><span class="visited"> </span>
<a id="L43"></a><span class="visited"> </span>
<a id="L44"></a><span class="visited"> </span>
<a id="L45"></a><span class="visited"> </span>
<a id="L46"></a><span class="visited"> </span>
<a id="L47"></a><span class="visited"> </span>
<a id="L48"></a><span class="visited"> </span>
<a id="L49"></a><span > </span>
<a id="L50"></a><span class="unvisited"> </span>
<a id="L51"></a><span > </span>
<a id="L52"></a><span class="unvisited"> </span>
<a id="L53"></a><span > </span>
<a id="L54"></a><span class="visited"> </span>
<a id="L55"></a><span > </span>
<a id="L56"></a><span class="visited"> </span>
<a id="L57"></a><span class="visited"> </span>
<a id="L58"></a><span class="visited"> </span>
<a id="L59"></a><span class="visited"> </span>
<a id="L60"></a><span > </span>
<a id="L61"></a><span class="unvisited"> </span>
<a id="L62"></a><span > </span>
<a id="L63"></a><span > </span>
<a id="L64"></a><span class="unvisited"> </span>
<a id="L65"></a><span class="unvisited"> </span>
<a id="L66"></a><span > </span>
<a id="L67"></a><span class="visited"> </span>
<a id="L68"></a><span > </span>
<a id="L69"></a><span class="visited"> </span>
<a id="L70"></a><span class="visited"> </span>
<a id="L71"></a><span class="visited"> </span>
<a id="L72"></a><span class="visited"> </span>
<a id="L73"></a><span > </span>
<a id="L74"></a><span class="unvisited"> </span>
<a id="L75"></a><span > </span>
<a id="L76"></a><span > </span>
<a id="L77"></a><span class="unvisited"> </span>
<a id="L78"></a><span class="unvisited"> </span>
<a id="L79"></a><span > </span>
<a id="L80"></a><span class="visited"> </span>
<a id="L81"></a><span > </span>
<a id="L82"></a><span class="visited"> </span>
<a id="L83"></a><span class="visited"> </span>
<a id="L84"></a><span > </span>
<a id="L85"></a><span class="visited"> </span>
<a id="L86"></a><span class="visited"> </span>
<a id="L87"></a><span class="visited"> </span>
<a id="L88"></a><span class="visited"> </span>
<a id="L89"></a><span class="visited"> </span>
<a id="L90"></a><span class="unvisited"> </span>
<a id="L91"></a><span class="visited"> </span>
<a id="L92"></a><span class="visited"> </span>
<a id="L93"></a><span class="visited"> </span>
<a id="L94"></a><span class="visited"> </span>
<a id="L95"></a><span class="unvisited"> </span>
<a id="L96"></a><span class="visited"> </span>
<a id="L97"></a><span > </span>
<a id="L98"></a><span class="visited"> </span>
<a id="L99"></a><span > </span>
<a id="L100"></a><span class="visited"> </span>
<a id="L101"></a><span class="visited"> </span>
<a id="L102"></a><span > </span>
<a id="L103"></a><span class="visited"> </span>
<a id="L104"></a><span > </span>
<a id="L105"></a><span class="visited"> </span>
<a id="L106"></a><span class="visited"> </span>
<a id="L107"></a><span class="visited"> </span>
<a id="L108"></a><span class="visited"> </span>
<a id="L109"></a><span class="visited"> </span>
<a id="L110"></a><span class="visited"> </span>
<a id="L111"></a><span class="visited"> </span>
<a id="L112"></a><span class="visited"> </span>
<a id="L113"></a><span class="unvisited"> </span>
<a id="L114"></a><span class="visited"> </span>
<a id="L115"></a><span class="unvisited"> </span>
<a id="L116"></a><span class="unvisited"> </span>
<a id="L117"></a><span > </span>
<a id="L118"></a><span class="visited"> </span>
<a id="L119"></a><span class="unvisited"> </span>
<a id="L120"></a><span > </span>
<a id="L121"></a><span > </span>
<a id="L122"></a><span class="visited"> </span>
</pre>
      </div>
      <div id="text-layer">
        <pre id="line-numbers">
<a href="#L1">  1</a>
<a href="#L2">  2</a>
<a href="#L3">  3</a>
<a href="#L4">  4</a>
<a href="#L5">  5</a>
<a href="#L6">  6</a>
<a href="#L7">  7</a>
<a href="#L8">  8</a>
<a href="#L9">  9</a>
<a href="#L10"> 10</a>
<a href="#L11"> 11</a>
<a href="#L12"> 12</a>
<a href="#L13"> 13</a>
<a href="#L14"> 14</a>
<a href="#L15"> 15</a>
<a href="#L16"> 16</a>
<a href="#L17"> 17</a>
<a href="#L18"> 18</a>
<a href="#L19"> 19</a>
<a href="#L20"> 20</a>
<a href="#L21"> 21</a>
<a href="#L22"> 22</a>
<a href="#L23"> 23</a>
<a href="#L24"> 24</a>
<a href="#L25"> 25</a>
<a href="#L26"> 26</a>
<a href="#L27"> 27</a>
<a href="#L28"> 28</a>
<a href="#L29"> 29</a>
<a href="#L30"> 30</a>
<a href="#L31"> 31</a>
<a href="#L32"> 32</a>
<a href="#L33"> 33</a>
<a href="#L34"> 34</a>
<a href="#L35"> 35</a>
<a href="#L36"> 36</a>
<a href="#L37"> 37</a>
<a href="#L38"> 38</a>
<a href="#L39"> 39</a>
<a href="#L40"> 40</a>
<a href="#L41"> 41</a>
<a href="#L42"> 42</a>
<a href="#L43"> 43</a>
<a href="#L44"> 44</a>
<a href="#L45"> 45</a>
<a href="#L46"> 46</a>
<a href="#L47"> 47</a>
<a href="#L48"> 48</a>
<a href="#L49"> 49</a>
<a href="#L50"> 50</a>
<a href="#L51"> 51</a>
<a href="#L52"> 52</a>
<a href="#L53"> 53</a>
<a href="#L54"> 54</a>
<a href="#L55"> 55</a>
<a href="#L56"> 56</a>
<a href="#L57"> 57</a>
<a href="#L58"> 58</a>
<a href="#L59"> 59</a>
<a href="#L60"> 60</a>
<a href="#L61"> 61</a>
<a href="#L62"> 62</a>
<a href="#L63"> 63</a>
<a href="#L64"> 64</a>
<a href="#L65"> 65</a>
<a href="#L66"> 66</a>
<a href="#L67"> 67</a>
<a href="#L68"> 68</a>
<a href="#L69"> 69</a>
<a href="#L70"> 70</a>
<a href="#L71"> 71</a>
<a href="#L72"> 72</a>
<a href="#L73"> 73</a>
<a href="#L74"> 74</a>
<a href="#L75"> 75</a>
<a href="#L76"> 76</a>
<a href="#L77"> 77</a>
<a href="#L78"> 78</a>
<a href="#L79"> 79</a>
<a href="#L80"> 80</a>
<a href="#L81"> 81</a>
<a href="#L82"> 82</a>
<a href="#L83"> 83</a>
<a href="#L84"> 84</a>
<a href="#L85"> 85</a>
<a href="#L86"> 86</a>
<a href="#L87"> 87</a>
<a href="#L88"> 88</a>
<a href="#L89"> 89</a>
<a href="#L90"> 90</a>
<a href="#L91"> 91</a>
<a href="#L92"> 92</a>
<a href="#L93"> 93</a>
<a href="#L94"> 94</a>
<a href="#L95"> 95</a>
<a href="#L96"> 96</a>
<a href="#L97"> 97</a>
<a href="#L98"> 98</a>
<a href="#L99"> 99</a>
<a href="#L100">100</a>
<a href="#L101">101</a>
<a href="#L102">102</a>
<a href="#L103">103</a>
<a href="#L104">104</a>
<a href="#L105">105</a>
<a href="#L106">106</a>
<a href="#L107">107</a>
<a href="#L108">108</a>
<a href="#L109">109</a>
<a href="#L110">110</a>
<a href="#L111">111</a>
<a href="#L112">112</a>
<a href="#L113">113</a>
<a href="#L114">114</a>
<a href="#L115">115</a>
<a href="#L116">116</a>
<a href="#L117">117</a>
<a href="#L118">118</a>
<a href="#L119">119</a>
<a href="#L120">120</a>
<a href="#L121">121</a>
<a href="#L122">122</a>
</pre>
<pre><code class="ocaml">open! Core
open! Ast

module Ctx = struct
  <span data-count="0">t</span>ype t = Term.t Var.Map.t [@@deriving sexp]

  let empty = Var.Map.empty
  let extend t ~var ~term = <span data-count="11563715">V</span>ar.Map.set t ~key:var ~data:term
  let lookup t var = <span data-count="15944970">V</span>ar.Map.find t var
end

let allowed_kinds arg_kind ret_kind =
  <span data-count="8899691">L</span>ist.mem
    Kind.[ Star, Star; Star, Box; Box, Star; Box, Box ]
    (arg_kind, ret_kind)
    ~equal:(fun kinds1 kinds2 -&gt; <span data-count="10696283">[</span>%compare: <span data-count="21392566">K</span>ind.t * Kind.t] kinds1 kinds2 = 0)
;;

let rec type_check t ~ctx =
  <span data-count="32791354">l</span>et open Term in
  match t with
  | <span data-count="15944970">V</span>ar var -&gt;
    (match Ctx.lookup ctx var with
    | <span data-count="15944970">S</span>ome term -&gt; term
    | <span data-count="0">N</span>one -&gt;
      raise_s
        [%message "Variable is unbound in typing context" (ctx : Ctx.t) (var : Var.t)])
  | <span data-count="3498368">A</span>pp { fun_; arg } -&gt;
    let fun_type = type_chec<span data-count="3498368">k</span> ~ctx fun_ |&gt; Eval.eval in
    <span data-count="3498368">(</span>match fun_type with
    | <span data-count="3498368">P</span>i { binder = var, arg_type; type_ = ret_type } -&gt;
      let arg_type' = type_check ~ctx arg in
      <span data-count="3498368">i</span>f not (Eval.beta_equa<span data-count="3498368">l</span> arg_type arg_type')
      then <span data-count="0">r</span>aise_<span data-count="0">s</span> [%message "Mismatching argument types" (arg_type : t) (arg_type' : t)];
      <span data-count="3498368">s</span>ubst ~var ~term:arg ret_type
    | <span data-count="0">_</span> -&gt; raise_s [%message "Application to a non-function type" (fun_ : t) (arg : t)])
  | <span data-count="2664051">F</span>un { binder = var, arg_type; body } -&gt;
    let (_ : t) = type_check ~ctx arg_type in
    <span data-count="2664051">l</span>et ret_type = type_check ~ctx:(Ctx.exten<span data-count="2664051">d</span> ctx ~var ~term:arg_type) body in
    <span data-count="2664051">l</span>et fun_type = Pi { binder = var, arg_type; type_ = ret_type } in
    let (_ : t) = type_check ~ctx fun_type in
    <span data-count="2664051">f</span>un_type
  | <span data-count="8899662">P</span>i { binder = var, kind; type_ } -&gt;
    let arg_kind = type_chec<span data-count="8899662">k</span> ~ctx kind |&gt; Eval.eval in
    <span data-count="8899662">l</span>et ret_kind = type_chec<span data-count="8899662">k</span> ~ctx:(Ctx.exten<span data-count="8899662">d</span> ctx ~var ~term:kind) type_ |&gt; Eval.eval in
    <span data-count="8899662">(</span>match arg_kind, ret_kind with
    | <span data-count="8899662">K</span>ind arg_kind, Kind ret_kind -&gt;
      if not (allowed_kind<span data-count="8899662">s</span> arg_kind ret_kind)
      then
        <span data-count="0">r</span>aise_<span data-count="0">s</span>
          [%message "Invalid kinds for pi-type" (arg_kind : Kind.t) (ret_kind : Kind.t)]
    | <span data-count="0">_</span> -&gt; raise_<span data-count="0">s</span> [%message "Expected kinds in pi-type" (arg_kind : t) (ret_kind : t)]);
    ret_kind
  | <span data-count="14">P</span>rod { left; right } -&gt;
    let left_kind = type_check ~ctx left in
    <span data-count="14">l</span>et right_kind = type_check ~ctx right in
    <span data-count="14">(</span>match left_kind, right_kind with
    | <span data-count="14">K</span>ind left_kind, Kind right_kind -&gt;
      if not (allowed_kind<span data-count="14">s</span> left_kind right_kind)
      then
        <span data-count="0">r</span>aise_<span data-count="0">s</span>
          [%message
            "Invalid kinds for prod-type" (left_kind : Kind.t) (right_kind : Kind.t)]
    | <span data-count="0">_</span> -&gt;
      raise_<span data-count="0">s</span> [%message "Expected kinds for prod-type" (left_kind : t) (right_kind : t)]);
    right_kind
  | <span data-count="15">S</span>um { left; right } -&gt;
    let left_kind = type_check ~ctx left in
    <span data-count="15">l</span>et right_kind = type_check ~ctx right in
    <span data-count="15">(</span>match left_kind, right_kind with
    | <span data-count="15">K</span>ind left_kind, Kind right_kind -&gt;
      if not (allowed_kind<span data-count="15">s</span> left_kind right_kind)
      then
        <span data-count="0">r</span>aise_<span data-count="0">s</span>
          [%message
            "Invalid kinds for sum-type" (left_kind : Kind.t) (right_kind : Kind.t)]
    | <span data-count="0">_</span> -&gt;
      raise_<span data-count="0">s</span> [%message "Expected kinds for sum-type" (left_kind : t) (right_kind : t)]);
    right_kind
  | <span data-count="1">P</span>air { fst; snd } -&gt;
    let fst_type = type_check ~ctx fst in
    <span data-count="1">l</span>et snd_type = type_check ~ctx snd in
    <span data-count="1">l</span>et prod_type = Prod { left = fst_type; right = snd_type } in
    let (_ : t) = type_check ~ctx prod_type in
    <span data-count="1">p</span>rod_type
  | <span data-count="1">F</span>st t -&gt;
    let prod_type = type_chec<span data-count="1">k</span> ~ctx t |&gt; Eval.eval in
    <span data-count="1">(</span>match prod_type with
    | <span data-count="1">P</span>rod { left; _ } -&gt; left
    | <span data-count="0">_</span> -&gt; raise_s [%message "Fst applied to non-product type" (t : t)])
  | <span data-count="1">S</span>nd t -&gt;
    let prod_type = type_chec<span data-count="1">k</span> ~ctx t |&gt; Eval.eval in
    <span data-count="1">(</span>match prod_type with
    | <span data-count="1">P</span>rod { right; _ } -&gt; right
    | <span data-count="0">_</span> -&gt; raise_s [%message "Snd applied to non-product type" (t : t)])
  | <span data-count="2">I</span>nl { val_; type_ = right_type } -&gt;
    let left_type = type_check ~ctx val_ in
    <span data-count="2">l</span>et sum_type = Sum { left = left_type; right = right_type } in
    let (_ : t) = type_check ~ctx sum_type in
    <span data-count="2">s</span>um_type
  | <span data-count="2">I</span>nr { val_; type_ = left_type } -&gt;
    let right_type = type_check ~ctx val_ in
    <span data-count="2">l</span>et sum_type = Sum { left = left_type; right = right_type } in
    let (_ : t) = type_check ~ctx sum_type in
    <span data-count="2">s</span>um_type
  | <span data-count="1">M</span>atch { matchee; inl = varl, bodyl; inr = varr, bodyr; type_ } -&gt;
    let sum_type = type_chec<span data-count="1">k</span> ~ctx matchee |&gt; Eval.eval in
    <span data-count="1">(</span>match sum_type with
    | <span data-count="1">S</span>um { left; right } -&gt;
      let inl_type = type_check ~ctx:(Ctx.exten<span data-count="1">d</span> ctx ~var:varl ~term:left) bodyl in
      <span data-count="1">l</span>et inr_type = type_check ~ctx:(Ctx.exten<span data-count="1">d</span> ctx ~var:varr ~term:right) bodyr in
      <span data-count="1">i</span>f not (Eval.beta_equa<span data-count="1">l</span> inl_type type_ &amp;&amp; <span data-count="1">E</span>val.beta_equa<span data-count="1">l</span> inr_type type_)
      then <span data-count="0">r</span>aise_<span data-count="0">s</span> [%message "Mismatching case return types"];
      <span data-count="1">t</span>ype_
    | <span data-count="0">_</span> -&gt; raise_s [%message "Match applied to non-sum type" (t : t)])
  | <span data-count="0">L</span>et { binder; val_; in_ } -&gt;
    type_check ~ctx (App { fun_ = Fun { binder; body = in_ }; arg = val_ })
  | <span data-count="1784266">K</span>ind Star -&gt; Kind Box
  | <span data-count="0">K</span>ind Box -&gt; raise_s [%message "No type for Box!"]
;;

let type_check t = <span data-count="3067">t</span>ype_check ~ctx:Ctx.empty t
</code></pre>
      </div>
    </div>
    <script src="../coverage.js"></script>
  </body>
</html>
